Imports System.Data.SqlClient

Public Class DAL
    Dim ds As New DataSet

    'Buscar el nombre del cliente
    Public Function buscar_nombre(ByVal codigo As String) As DataSet
        Try
            Dim conect As New SqlConnection(conexion)
            Dim cmd As New SqlCommand
            cmd.CommandText = "SELECT nombre FROM Socios WHERE codigo=@codigo"
            cmd.CommandType = CommandType.Text
            cmd.Connection = conect

            '*****Crear parametros que se pasaran*********
            Dim pcodigo As New SqlParameter("@codigo", SqlDbType.NChar, 13)
            pcodigo.Value = codigo
            cmd.Parameters.Add(pcodigo)

            '*****Crear adaptador*********
            Dim adaptador As New SqlDataAdapter(cmd)
            adaptador.Fill(ds, "Socios")
            '*******Retornar al DataSet con los datos*********
            Return ds
        Catch ex As Exception
            Throw ex
        End Try
    End Function

    'Buscar cantidad de peliculas y titulos en stock
    Public Function buscar_cant_y_titulos(ByVal codigo_pelicula) As DataSet
        Try
            Dim conect As New SqlConnection(conexion)
            Dim cmd As New SqlCommand
            cmd.CommandText = "SELECT copias,titulo,rentadas FROM Peliculas WHERE codigo_pelicula=@codigo_pelicula"
            cmd.CommandType = CommandType.Text
            cmd.Connection = conect

            '*****Crear parametros que se pasaran*********
            Dim pcodigo_pelicula As New SqlParameter("@codigo_pelicula", SqlDbType.Int)
            pcodigo_pelicula.Value = codigo_pelicula
            cmd.Parameters.Add(pcodigo_pelicula)

            '*****Crear adaptador*********
            Dim adaptador As New SqlDataAdapter(cmd)
            adaptador.Fill(ds, "Peliculas")
            '*******Retornar al DataSet con los datos*********
            Return ds
        Catch ex As Exception
            Throw ex
        End Try
    End Function

    Public Sub actualizar_cantidades(ByVal codigo_pelicula As Integer, ByVal copias As Integer, ByVal rentadas As Integer)
        Try
            Dim conect As New SqlConnection(conexion)
            Dim cmd As New SqlCommand
            cmd.CommandText = "Update Peliculas set Copias = @Copias, rentadas=@Rentadas where Codigo_Pelicula = @Codigo_Pelicula"
            cmd.CommandType = CommandType.Text
            cmd.Connection = conect

            '==================================================================================================
            '*******Para pasar los parametros que seran actualizados en la DB*********
            Dim pcopias As New SqlParameter("@Copias", SqlDbType.Int)
            pcopias.Value = copias
            cmd.Parameters.Add(pcopias)

            Dim pcodigo_pelicula As New SqlParameter("@codigo_pelicula", SqlDbType.Int)
            pcodigo_pelicula.Value = codigo_pelicula
            cmd.Parameters.Add(pcodigo_pelicula)

            Dim prentadas As New SqlParameter("@rentadas", SqlDbType.Int)
            prentadas.Value = rentadas
            cmd.Parameters.Add(prentadas)

            '==================================================================================================
            'Para ejecutar sentencias sin necesidad de traer datos

            cmd.Connection.Open()  'Abre conexion a la Tabla
            cmd.ExecuteNonQuery()   'Ejecuta Query
            cmd.Connection.Close() 'Cierra conexion a la tabla
        Catch ex As Exception
            Throw ex
        End Try
    End Sub

    Public Function cargar_peliculas() As DataSet
        Try
            Dim conect As New SqlConnection(conexion)
            Dim cmd As New SqlCommand
            cmd.CommandText = "select * from Peliculas"
            cmd.CommandType = CommandType.Text
            cmd.Connection = conect
            '*****Crear adaptador*********
            Dim adaptador As New SqlDataAdapter(cmd)
            adaptador.Fill(ds, "Peliculas")
            '*******Retornar al DataSet con los datos*********
            Return ds
        Catch ex As Exception
            Throw ex
        End Try
    End Function

    Public Function alquiler() As DataSet
        Try
            Dim conect As New SqlConnection(conexion)
            Dim cmd As New SqlCommand
            cmd.CommandText = "select * from alquiler"
            cmd.CommandType = CommandType.Text
            cmd.Connection = conect
            '*****Crear adaptador*********
            Dim adaptador As New SqlDataAdapter(cmd)
            adaptador.Fill(ds, "Alquiler")
            '*******Retornar al DataSet con los datos*********
            Return ds
        Catch ex As Exception
            Throw ex
        End Try
    End Function

    'Grabar Datos de alquiler
    Public Sub registrar_alquiler(ByVal numero_socio As String, ByVal numero_cinta As Integer)
        Try
            Dim conect As New SqlConnection(conexion)
            Dim cmd As New SqlCommand
            cmd.CommandText = "INSERT INTO Alquiler (numero_socio, fecha_prestamo, numero_cinta) VALUES (@numero_socio, getdate(), @numero_cinta)"
            cmd.CommandType = CommandType.Text
            cmd.Connection = conect

            '==================================================================================================
            '*******Para pasar los parametros que seran actualizados en la DB*********
            Dim pNumero_socio As New SqlParameter("@Numero_socio", SqlDbType.VarChar, 13)
            pNumero_socio.Value = numero_socio
            cmd.Parameters.Add(pNumero_socio)


            Dim pnumero_cinta As New SqlParameter("@numero_cinta", SqlDbType.Int)
            pnumero_cinta.Value = numero_cinta
            cmd.Parameters.Add(pnumero_cinta)

            '==================================================================================================
            'Para ejecutar sentencias sin necesidad de traer datos

            cmd.Connection.Open()  'Abre conexion a la Tabla
            cmd.ExecuteNonQuery()   'Ejecuta Query
            cmd.Connection.Close() 'Cierra conexion a la tabla
        Catch ex As Exception
            Throw ex
        End Try
    End Sub

    'Buscar si existe
    Public Function consultar_existe(ByVal codigo_pelicula As Integer) As DataSet
        Try
            Dim conect As New SqlConnection(conexion)
            Dim cmd As New SqlCommand
            cmd.CommandText = "SELECT codigo_pelicula FROM Lista_espera WHERE codigo_pelicula=@codigo_pelicula"
            cmd.CommandType = CommandType.Text
            cmd.Connection = conect

            '*****Crear parametros que se pasaran*********
            Dim pcodigo_pelicula As New SqlParameter("@codigo_pelicula", SqlDbType.Int)
            pcodigo_pelicula.Value = codigo_pelicula
            cmd.Parameters.Add(pcodigo_pelicula)

            '*****Crear adaptador*********
            Dim adaptador As New SqlDataAdapter(cmd)
            adaptador.Fill(ds, "Lista_espera")
            '*******Retornar al DataSet con los datos*********
            Return ds
        Catch ex As Exception
            Throw ex
        End Try
    End Function
End Class

